#######################################################################
##### Part of the VortexGE Configuration Script                   #####
##### Copyright (C) 2004-2006 Aloysius Indrayanto                 #####
##### GNU Lesser General Public License                           #####
##### ----------------------------------------------------------- #####
##### EDITING THIS FILE ERRONEOUSLY MAY CAUSE THIS SCRIPT TO FAIL #####
##### ----------------------------------------------------------- #####
##### This program is distributed WITHOUT ANY WARRANTY.           #####
##### See the GNU Lesser General Public License for more details. #####
#######################################################################

#######################################################################
##### Functions for Checking GCC
#######################################################################

##### Get the given g++ version
GetGppVersion()
{
  echo '#include <stdio.h>'                                                              > $GppGVTestF.cc
  echo 'int main(void)'                                                                 >> $GppGVTestF.cc
  echo '{'                                                                              >> $GppGVTestF.cc
  echo '  printf("%d", __GNUC__ * 10000 + __GNUC_MINOR__ * 100 + __GNUC_PATCHLEVEL__);' >> $GppGVTestF.cc
  echo '  return(0);'                                                                   >> $GppGVTestF.cc
  echo '}'                                                                              >> $GppGVTestF.cc
  eval $1 $GppGVTestF.cc -o $GppGVTestF >/dev/null 2>&1
  if (( $? != 0 )); then
    export $2=0
  else
    export $2=`./$GppGVTestF`
  fi
  rm -f $GppGVTestF.cc $GppGVTestF
}

##### Find the best g++ in the system
FindTheBestGpp()
{
  local __Loc__
  local __Bin__
  local __Cmd__
  local __Ver__
  for __Loc__ in $GNUBinLoc; do
    if [[ ! -e $__Loc__ ]]; then
      continue
    fi
    for __Bin__ in `ls $__Loc__ | grep '^g++'`; do
      __Cmd__=$__Loc__/$__Bin__
      GetGppVersion $__Cmd__ __Ver__
      if (( __Ver__ > GNUGppVer )); then
        if [[ -x ${__Cmd__//++/cc} ]]; then
          export $1=${__Cmd__//++/cc}
        else
          export $1=gcc
      fi
        export $2=$__Cmd__
        export $3=$__Ver__
      fi
    done
  done
}
